<?php

include_once('../includes/system.php');

class Export extends Module
{
  var $Id;
  var $AnoNe = array('Ne', 'Ano');
  var $WhereLang;
  var $WhereUsers;
  var $SelectedUsers;
  var $UserNames;
  var $ClientVersion;
  var $OrderByUserList;
  
  function Init()
  {
    $this->TempDir = $this->Config['Web']['TempFolder'].'Export/'.$this->Id.'/';
    if(!file_exists($this->TempDir)) mkdir($this->TempDir, 0777, true);
  }
  
  function LoadFilters()
  {  
    $DbResult = $this->Database->query('SELECT * FROM `Export` WHERE `Id`='.$this->Id);
    if($DbResult->num_rows == 0) die('Export '.$this->Id.' neexistuje');
    $this->Export = $DbResult->fetch_assoc();
    
    // Filter selected languages
    $this->WhereLang = '';
    $DbResult = $this->Database->query('SELECT * FROM `ExportLanguage` WHERE `Export`='.$this->Id.' ORDER BY `Sequence`');
    echo($this->Database->error);
    while($Language = $DbResult->fetch_assoc())
      $this->WhereLang .= ' OR (`Language` = '.$Language['Language'].')'; 
    if($this->WhereLang == '') $this->WhereLang = 1; 
      else $this->WhereLang = '('.substr($this->WhereLang, 4).')';

    // Filter selected users
    $this->SelectedUsers = '';  
    $this->UserNames = '';
    $DbResult = $this->Database->query('SELECT `ExportUser`.*, `User`.`Name`, `User`.`ID` FROM `ExportUser` LEFT JOIN `User` ON `User`.`ID`=`ExportUser`.`User` WHERE `ExportUser`.`Export`='.$this->Id.' ORDER BY `ExportUser`.`Sequence`');
    while($UserLine = $DbResult->fetch_assoc())
    {
      $this->SelectedUsers .= ','.$UserLine['ID'];
      $this->UserNames .= ','.$UserLine['Name'];
    }
    $this->SelectedUsers = substr($this->SelectedUsers, 1);
    $this->UserNames = substr($this->UserNames, 1);      
   
    if($this->SelectedUsers == '')
    {
      $this->WhereUsers = 0;
      $this->OrderByUserList = '';
    } else
    {
      $this->WhereUsers = '(`User` IN ('.$this->SelectedUsers.'))';
      $this->OrderByUserList = ' ORDER BY FIELD(`User`, '.$this->SelectedUsers.')';
    }
    
    $DbResult = $this->Database->query('SELECT * FROM `ClientVersion` WHERE `Id`='.$this->Export['ClientVersion']);
    $this->ClientVersion = $DbResult->fetch_assoc();    
  }

  function ExportToMangosSQL()
  {
    global $TranslationTree, $LanguageList, $User, $Config;
  
    $this->LoadFilters();
    
    $Buffer = 
      "-- Generováno projektem wowpreklad.zdechov.net\n". 
      "-- ===========================================\n".
      "--\n".
      "-- Web projektu: ".$this->Config['Web']['BaseURL']."\n".
      "-- Datum exportu: ".date("j.n.Y  H:i:s")."\n".
      "-- Znaková sada: ".$this->Config['Database']['Charset']." / ".$this->Config['Web']['Charset']."\n".
      "-- Diakritika: ".$this->AnoNe[$this->Export['WithDiacritic']]."\n".
      "-- Vygeneroval uživatel: ".$User->Name."\n".
      "-- Vzato od uživatelů: ".$this->UserNames."\n".
      "-- Generované tabulky: ";
    
    $DbResult = $this->Database->query('SELECT `Group`.* FROM `ExportGroup` JOIN `Group` ON `Group`.`Id` = `ExportGroup`.`Group` WHERE `ExportGroup`.`Export`='.$this->Id);
    while($Group = $DbResult->fetch_assoc())
    {
      $Buffer .= $Group['TablePrefix'].', ';
    }
    $Buffer .= "\n\n";  

    $DbResult = $this->Database->query('SELECT `Group`.* FROM `ExportGroup` JOIN `Group` ON `Group`.`Id` = `ExportGroup`.`Group` WHERE `ExportGroup`.`Export`='.$this->Id);
    while($Group = $DbResult->fetch_assoc())
    {
      if($Group['MangosTable'] != '')
      {
        $Query = 'SELECT * FROM (SELECT * FROM '.$Group['TablePrefix'].' WHERE (`Complete` = 1) AND `VersionStart` <= '.$this->ClientVersion['BuildNumber'].' AND `VersionEnd` >= '.$this->ClientVersion['BuildNumber'].' AND '.$this->WhereLang.' AND '.$this->WhereUsers.$this->OrderByUserList.') AS `T` GROUP BY `T`.`Entry`';  
        //echo($Query);
        $Buffer .= "\n\n-- ".$Group['Name']."\n\n";
        $DbResult2 = $this->Database->query($Query);
        while($Line = $DbResult2->fetch_array()) 
        {
          $Values = '';
          foreach($TranslationTree[$Group['Id']]['Items'] as $GroupItem)
          if($GroupItem['Column'] != $Group['PrimaryKeyItem']) // Do not update primary key
          {
            if($GroupItem['MangosColumn'] == '') $GroupItem['MangosColumn'] = $GroupItem['Column'];
            $Values .= ', `'.$GroupItem['MangosColumn'].'`="'.addslashes($Line[$GroupItem['Column']]).'"';
          }
          $Values = substr($Values, 2);

          $ColumnItems = explode(',', $Group['MangosTableIndex']);
          if(count($ColumnItems) > 1) 
          {
            $Where = 'CONCAT(';
            foreach($ColumnItems as $ColumnItem)
              $Where .= '`'.$ColumnItem.'`, "_", ';
            $Where = substr($Where, 0, -7).')';
          } else $Where = '`'.$Group['MangosTableIndex'].'`';
          $Where .= ' = "'.$Line[$Group['PrimaryKeyItem']].'";'; 
          $Line = 'UPDATE `'.$Group['MangosTable'].'` SET '.$Values.' WHERE '.$Where;
          $Line = str_replace("\n", '\n', $Line);
          $Line = str_replace("\r", '', $Line);
          $Buffer .= $Line."\n";
        }     
      }
    }
    if($this->Export['WithDiacritic'] != 1) $Buffer = utf2ascii($Buffer);
    return($Buffer);
  }
  
  function ExportToAoWoWSQL() 
  {
    global $Config, $TranslationTree, $AoWoWconf, $LanguageList;
  
    require_once('../aowow/configs/config.php');
  
    $Buffer = $this->ExportToMangosSQL();
  
    // Data to aowow

    $Database2 = new mysqli($this->Config['Database']['Host'], $this->Config['Database']['User'], $this->Config['Database']['Password'], $this->Config['Database']['Database']);
    $Database2->query('SET NAMES '.$this->Config['Database']['Charset']);
    $Database2->select_db($AoWoWconf['mangos']['db']);    
    $AoWoWTables = array(
      'aowow_resistances' => 'Id', 
      'aowow_spelldispeltype' => 'Id', 
      'aowow_skill' => 'skillID',
    );
    foreach($AoWoWTables as $AoWoWTable => $IndexColum) 
    {
      $Buffer .= '--'.$AoWoWTable.', ';
      $Buffer .= "\n\n";  
      $Query = 'SELECT `name`,`'.$IndexColum.'` FROM `'.$AoWoWTable.'`';
      $DbResult = $Database2->query($Query);
      while($Line = $DbResult->fetch_assoc()) 
      {
        $Ori_text = $Line['name'];
        $DbResult2 = $Database2->query('SELECT `Text` AS `En`,
        (SELECT `Text` FROM `'.$Config['Database']['Database'].'`.`TextGlobalString` AS `TableTran`
         WHERE `TableEn`.`Entry` = `TableTran`.`Entry` AND (`Complete` = 1) AND '.$this->WhereLang.' AND '.$this->WhereUsers.$this->OrderByUserList.' LIMIT 1) AS `Tran`
         FROM `'.$Config['Database']['Database'].'`.`TextGlobalString` AS `TableEn` WHERE
          `Text` = "'.addslashes($Ori_text).'" LIMIT 1');
        $Tran = $DbResult2->fetch_assoc();
        //echo ($Line['name'].'='.$Tran['tran']);
        if($Tran['Tran'] == '') 
        {
          $DbResult2 = $Database2->query('SELECT `OptionText` AS `En`,
          (SELECT `OptionText` FROM `'.$this->Config['Database']['Database'].'`.`TextNPCOption` AS `TableTran`
           WHERE `TableEn`.`Entry` = `TableTran`.`Entry` AND (`Complete` = 1) AND '.$this->WhereLang.'
            AND '.$this->WhereUsers.$this->OrderByUserList.' LIMIT 1) AS `Tran`
          FROM `'.$this->Config['Database']['Database'].'`.`TextNPCOption` AS `TableEn` WHERE
            `OptionText` = "'.addslashes($Ori_text).'" LIMIT 1');
          $Tran = $DbResult2->fetch_assoc();
        }
        
        if($Tran['Tran'] <> '')
          $Buffer .= 'UPDATE `'.$AoWoWTable.'` SET `name` = "'.addslashes($Tran['Tran']).'" WHERE '.$IndexColum.' = '.$Line[$IndexColum].' ;'."\n";
      }
      $Buffer .= "\n\n";  
    }
    if($this->Export['WithDiacritic'] != 1) $Buffer = utf2ascii($Buffer);
    return($Buffer);
  }  
 
  
  function ExportToXML()
  {
    global $TranslationTree, $LanguageList, $User;
  
    $this->LoadFilters($this->Id);

    $Buffer = '<?xml version="1.0" encoding="utf-8"?>'."\n".
    "<document>\n".
    "  <meta>\n".
    "    <projecturl>".$this->Config['Web']['BaseURL']."</projecturl>\n".
    "    <time>".date('r')."</time>\n".
    "    <diacritics mode=".'"'.$this->Export['WithDiacritic'].'"'." />\n".
    "    <author>".$User->Name."</author>\n".
    "    <contributors>\n";
    foreach(explode(',', $this->UserNames) as $UserName)
      $Buffer .= "      <user>".$UserName."</user>\n";
    $Buffer .= 
    "    </contributors>\n".
    "  </meta>\n".
    "  <translation>\n";

    $DbResult = $this->Database->query('SELECT `Group`.* FROM `ExportGroup` JOIN `Group` ON `Group`.`Id` = `ExportGroup`.`Group` WHERE `ExportGroup`.`Export`='.$this->Id);
    while($Group = $DbResult->fetch_assoc())
    {
      if($Group['MangosTable'] == '')
      {
        $Group['MangosTable'] = $Group['TablePrefix'];
        $Group['MangosTableIndex'] = 'entry';
      }
      $Query = 'SELECT *,(SELECT `Name` FROM `User` WHERE `User`.`ID`=`T`.`User`) AS `UserName` FROM (SELECT * FROM `'.$Group['TablePrefix'].'` WHERE (`Complete` = 1) AND (`VersionStart` <= '.$this->ClientVersion['BuildNumber'].') AND (`VersionEnd` >= '.$this->ClientVersion['BuildNumber'].') AND '.$this->WhereLang.' AND '.$this->WhereUsers.$this->OrderByUserList.') AS `T` GROUP BY `T`.`entry`'; 
      //echo($Query);
      $Buffer .= '    <group id="'.$Group['Id'].'" name="'.$Group['TablePrefix'].'">'."\n";
      $DbResult2 = $this->Database->query($Query);
      while($Line = $DbResult2->fetch_assoc()) 
      {
        $Buffer .= '      <item id="'.$Line['Entry'].'" user="'.$Line['UserName'].'">'."\n";
        $Values = '';
        foreach($TranslationTree[$Group['Id']]['Items'] as $GroupItem)
        {
          if($GroupItem['MangosColumn'] == '') $GroupItem['MangosColumn'] = $GroupItem['Column'];
          if($Line[$GroupItem['Column']] != '')
          $Buffer .= '        <text index="'.$GroupItem['Id'].'" name="'.$GroupItem['Column'].'">'.addslashes($Line[$GroupItem['Column']]).'</text>'."\n";
        }
        $Buffer .= "      </item>\n";
      }    
      $Buffer .= "    </group>\n";
    }
    if($this->Export['WithDiacritic'] != 1) $Buffer = utf2ascii($Buffer);
    $Buffer .= "  </translation>\n".
  "</document>";
    return($Buffer);
  }      

  function ExportToDBC()
  {
    global $TranslationTree, $LanguageList, $Config;
  
    $this->LoadFilters();
        
    $DbResult = $this->Database->query('SELECT `Group`.* FROM `ExportGroup` JOIN `Group` ON `Group`.`Id` = `ExportGroup`.`Group` WHERE `ExportGroup`.`Export`='.$this->Id.' AND `Group`.`DBCFileName` != ""');
    echo('Počet generovaných skupin: '.$DbResult->num_rows.'<br/>'."\n");
    while($Group = $DbResult->fetch_assoc())
    {
      echo($Group['Name'].', ');
      if(file_exists('../source/'.$this->ClientVersion['Version'].'/dbc/'.$Group['DBCFileName'].'.dbc')) 
      {
        $i = 1;
        $columns = '';
        foreach($TranslationTree[$Group['Id']]['Items'] as $Column) 
        {
          $columns .= ' `T`.`'.$Column['Column'].'` AS `Text'.$i.'`,';
          $i = $i + 1;
        }
        $Query = 'SELECT '.$columns.' `T`.`Entry` AS `Entry` FROM (SELECT * FROM `'.$Group['TablePrefix'].'` WHERE (`Complete` = 1) AND '.$this->WhereLang.' AND '.$this->WhereUsers.' AND (`VersionStart` <= '.$this->ClientVersion['BuildNumber'].') AND (`VersionEnd` >= '.$this->ClientVersion['BuildNumber'].')) AS `T` GROUP BY `T`.`Entry`';
        $Query = str_replace('`', '\`', $Query);
        $Query = '"'.str_replace(' ', '\ ', $Query).'"';
      
        $params = '-u '.$Config['Database']['User'].' -p '.$Config['Database']['Password'].' -f ../source/'.$this->ClientVersion['Version'].'/dbc/'.$Group['DBCFileName'].'.dbc -n '.$this->TempDir.'dbc/'.$Group['DBCFileName'].'.dbc -c '.GetDBCColumns($this->ClientVersion['Version'], $Group['DBCFileName']).' -q '.$Query;
      
        //echo('./DBCExport '.$params);       
        exec('./DBCExport '.$params);
       
      } else echo('Zdrojový soubor '.'../source/'.$this->ClientVersion['Version'].'/dbc/'.$Group['DBCFileName'].'.dbc'.' nenalezen.'."\n");
    }
    echo('Hotovo <br />');
  }

  function ExportToLua()
  {
    global $TranslationTree, $LanguageList;
  
    $this->LoadFilters();

    $DbResult = $this->Database->query('SELECT `Group`.* FROM `ExportGroup` JOIN `Group` ON `Group`.`Id` = `ExportGroup`.`Group` WHERE `ExportGroup`.`Export`='.$this->Id.' AND `Group`.`LuaFileName` != ""');
    while($Group = $DbResult->fetch_assoc())
    {
      echo($Group['Name'].'... ');
      $File = new FileStream();
      $File->OpenFile('../source/'.$this->ClientVersion['Version'].'/lua/'.$Group['LuaFileName'].'.lua');
      $File2 = new FileStream();
      if(!file_exists($this->TempDir.'lua/')) mkdir($this->TempDir.'lua/', 0777, true);
      $File2->CreateFile($this->TempDir.'lua/'.$Group['LuaFileName'].'.lua');
 
      while(!$File->EOF())
      {
        $Line = $File->ReadLine();
        if(strpos($Line, '=') !== false)
        {
          $LineParts = explode(';', $Line);
          $LineParts2 = explode('=', $LineParts[0]);
          $Value['ShortCut'] = trim($LineParts2[0]);
          $Value['Text'] = substr(trim($LineParts2[1]), 1, -1);
          $Value['Comment'] = substr(trim($LineParts[1]), 3);

          $Query = 'SELECT * FROM (SELECT * FROM `'.$Group['TablePrefix'].'` WHERE (`Complete` = 1) AND '.$this->WhereLang.' AND '.$this->WhereUsers.' AND (`ShortCut`="'.$Value['ShortCut'].'") AND (`VersionStart` <= '.$this->ClientVersion['BuildNumber'].') AND (`VersionEnd` >= '.$this->ClientVersion['BuildNumber'].')'.$this->OrderByUserList.') AS `T` GROUP BY `T`.`Entry`';
          //echo($Query);
          $DbResult2 = $this->Database->query($Query);
          if($DbResult2->num_rows > 0)
          {
            $DbRow = $DbResult2->fetch_assoc();
            $Value['Text'] = addslashes($DbRow['Text']);
            // Escape new line control characters
            $Value['Text'] = str_replace("\n", '\n', $Value['Text']);
            $Value['Text'] = str_replace("\r", '', $Value['Text']);
            $Value['Comment'] = $DbRow['Comment'];
            // Only one line comments allowed
            $Value['Comment'] = str_replace("\n", ' ', $Value['Comment']);
            $Value['Comment'] = str_replace("\r", '', $Value['Comment']);
            //echo('.');
          }
          $NewLine = $Value['ShortCut'].' = "'.$Value['Text'].'";';
          if($Value['Comment'] != '') $NewLine .= ' -- '.$Value['Comment'];
          $NewLine .= "\n";
          $File2->WriteLine($NewLine);
        } else $File2->WriteLine($Line."");
      }
      echo('Hotovo <br/>');
    }
  }
}

?>
